com.fasterxml.jackson.databind.deser.impl

## Class ManagedReferenceProperty

- java.lang.Object
- - com.fasterxml.jackson.databind.deser.SettableBeanProperty
  - - com.fasterxml.jackson.databind.deser.impl.ManagedReferenceProperty

- All Implemented Interfaces:
    BeanProperty, Named, Serializable

      public final class ManagedReferenceProperty
      extends SettableBeanProperty

  Wrapper property that is used to handle managed (forward) properties Basically just needs to delegate first to actual forward property, and then to back property.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.fasterxml.jackson.databind.BeanProperty

      `BeanProperty.Std`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected SettableBeanProperty` | `_backProperty`
    `protected boolean` | `_isContainer` Flag that indicates whether property to handle is a container type (array, Collection, Map) or not.
    `protected SettableBeanProperty` | `_managedProperty`
    `protected String` | `_referenceName`

    - ### Fields inherited from class com.fasterxml.jackson.databind.deser.SettableBeanProperty

      `_contextAnnotations, _managedReferenceName, _metadata, _nullProvider, _objectIdInfo, _propertyIndex, _propName, _type, _valueDeserializer, _valueTypeDeserializer, _viewMatcher, _wrapperName, MISSING_VALUE_DESERIALIZER`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `ManagedReferenceProperty(ManagedReferenceProperty src, JsonDeserializer<?> deser)`
    `protected` | `ManagedReferenceProperty(ManagedReferenceProperty src, PropertyName newName)`
    `` | `ManagedReferenceProperty(SettableBeanProperty forward, String refName, SettableBeanProperty backward, Annotations contextAnnotations, boolean isContainer)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `deserializeAndSet(JsonParser jp, DeserializationContext ctxt, Object instance)` Method called to deserialize appropriate value, given parser (and context), and set it using appropriate mechanism.
    `Object` | `deserializeSetAndReturn(JsonParser jp, DeserializationContext ctxt, Object instance)` Alternative to `SettableBeanProperty.deserializeAndSet(com.fasterxml.jackson.core.JsonParser, com.fasterxml.jackson.databind.DeserializationContext, java.lang.Object)` that returns either return value of setter method called (if one is), or null to indicate that no return value is available.
    `<A extends Annotation> A` | `getAnnotation(Class<A> acls)` Method for finding annotation associated with this property; meaning annotation associated with one of entities used to access property.
    `AnnotatedMember` | `getMember()` Method for accessing primary physical entity that represents the property; annotated field, method or constructor property.
    `void` | `set(Object instance, Object value)` Method called to assign given value to this property, on specified Object.
    `Object` | `setAndReturn(Object instance, Object value)` Method called to assign given value to this property, on specified Object, and return whatever delegating accessor returned (if anything)
    `ManagedReferenceProperty` | `withName(PropertyName newName)` Fluent factory method for constructing and returning a new instance with specified property name.
    `ManagedReferenceProperty` | `withValueDeserializer(JsonDeserializer<?> deser)` Fluent factory method for constructing and returning a new instance with specified value deserializer.

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.SettableBeanProperty

      `_throwAsIOE, _throwAsIOE, assignIndex, depositSchemaProperty, deserialize, getContextAnnotation, getCreatorIndex, getDeclaringClass, getFullName, getInjectableValueId, getManagedReferenceName, getMetadata, getName, getObjectIdInfo, getPropertyIndex, getType, getValueDeserializer, getValueTypeDeserializer, getWrapperName, hasValueDeserializer, hasValueTypeDeserializer, hasViews, isRequired, setManagedReferenceName, setObjectIdInfo, setViews, toString, visibleInView, withName, withSimpleName`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### _referenceName

          protected final String _referenceName

    - #### _isContainer

          protected final boolean _isContainer

      Flag that indicates whether property to handle is a container type (array, Collection, Map) or not.

    - #### _managedProperty

          protected final SettableBeanProperty _managedProperty

    - #### _backProperty

          protected final SettableBeanProperty _backProperty

  - ### Constructor Detail

    - #### ManagedReferenceProperty

          public ManagedReferenceProperty(SettableBeanProperty forward,
                                  String refName,
                                  SettableBeanProperty backward,
                                  Annotations contextAnnotations,
                                  boolean isContainer)

    - #### ManagedReferenceProperty

          protected ManagedReferenceProperty(ManagedReferenceProperty src,
                                  JsonDeserializer<?> deser)

    - #### ManagedReferenceProperty

          protected ManagedReferenceProperty(ManagedReferenceProperty src,
                                  PropertyName newName)

  - ### Method Detail

    - #### withName

          public ManagedReferenceProperty withName(PropertyName newName)

      Description copied from class: `SettableBeanProperty`
      Fluent factory method for constructing and returning a new instance with specified property name. Note that this method should NOT change configuration of this instance.
      Specified by:
        `withName` in class `SettableBeanProperty`
      Parameters:
        `newName` - Name to use for the new instance.
      Returns:
        Newly constructed instance, if property name differs from the one used for this instance; or 'this' if not.

    - #### withValueDeserializer

          public ManagedReferenceProperty withValueDeserializer(JsonDeserializer<?> deser)

      Description copied from class: `SettableBeanProperty`
      Fluent factory method for constructing and returning a new instance with specified value deserializer. Note that this method should NOT change configuration of this instance.
      Specified by:
        `withValueDeserializer` in class `SettableBeanProperty`
      Parameters:
        `deser` - Deserializer to assign to the new property instance
      Returns:
        Newly constructed instance, if value deserializer differs from the one used for this instance; or 'this' if not.

    - #### getAnnotation

          public <A extends Annotation> A getAnnotation(Class<A> acls)

      Description copied from interface: `BeanProperty`
      Method for finding annotation associated with this property; meaning annotation associated with one of entities used to access property.
      Specified by:
        `getAnnotation` in interface `BeanProperty`
      Specified by:
        `getAnnotation` in class `SettableBeanProperty`

    - #### getMember

          public AnnotatedMember getMember()

      Description copied from interface: `BeanProperty`
      Method for accessing primary physical entity that represents the property; annotated field, method or constructor property.
      Specified by:
        `getMember` in interface `BeanProperty`
      Specified by:
        `getMember` in class `SettableBeanProperty`

    - #### deserializeAndSet

          public void deserializeAndSet(JsonParser jp,
                               DeserializationContext ctxt,
                               Object instance)
                                 throws IOException,
                                        JsonProcessingException

      Description copied from class: `SettableBeanProperty`
      Method called to deserialize appropriate value, given parser (and context), and set it using appropriate mechanism. Pre-condition is that passed parser must point to the first token that should be consumed to produce the value (the only value for scalars, multiple for Objects and Arrays).
      Specified by:
        `deserializeAndSet` in class `SettableBeanProperty`
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### deserializeSetAndReturn

          public Object deserializeSetAndReturn(JsonParser jp,
                                       DeserializationContext ctxt,
                                       Object instance)
                                         throws IOException,
                                                JsonProcessingException

      Description copied from class: `SettableBeanProperty`
      Alternative to `SettableBeanProperty.deserializeAndSet(com.fasterxml.jackson.core.JsonParser, com.fasterxml.jackson.databind.DeserializationContext, java.lang.Object)` that returns either return value of setter method called (if one is), or null to indicate that no return value is available. Mostly used to support Builder style deserialization.
      Specified by:
        `deserializeSetAndReturn` in class `SettableBeanProperty`
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### set

          public final void set(Object instance,
                 Object value)
                         throws IOException

      Description copied from class: `SettableBeanProperty`
      Method called to assign given value to this property, on specified Object.

      Note: this is an optional operation, not supported by all implementations, creator-backed properties for example do not support this method.

      Specified by:
        `set` in class `SettableBeanProperty`
      Throws:
        `IOException`

    - #### setAndReturn

          public Object setAndReturn(Object instance,
                            Object value)
                              throws IOException

      Description copied from class: `SettableBeanProperty`
      Method called to assign given value to this property, on specified Object, and return whatever delegating accessor returned (if anything)

      Note: this is an optional operation, not supported by all implementations, creator-backed properties for example do not support this method.

      Specified by:
        `setAndReturn` in class `SettableBeanProperty`
      Throws:
        `IOException`

Copyright © 2014 FasterXML. All Rights Reserved.